import { Component } from '@angular/core';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';

import DOMPurify from 'dompurify';

/**
 * Central component of the app.
 */
@Component({
    selector: 'in-app-root',
    templateUrl: './app.component.html'
})
export class AppComponent {

    /**
     * @ignore
     */
    constructor(private sanitizer: DomSanitizer) {
    }

    transform(html: string | undefined | null): string | SafeHtml {
//        return this.sanitizer.bypassSecurityTrustHtml(DOMPurify.sanitize(html ?? ''));
        return this.sanitizer.bypassSecurityTrustHtml(html ?? '');
    }
}
